/* Generated automatically by the program `genpeep'
from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "insn-config.h"
#include "hash-set.h"
#include "machmode.h"
#include "vec.h"
#include "double-int.h"
#include "input.h"
#include "alias.h"
#include "symtab.h"
#include "wide-int.h"
#include "inchash.h"
#include "tree.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "rtl.h"
#include "tm_p.h"
#include "regs.h"
#include "output.h"
#include "recog.h"
#include "except.h"
#include "function.h"
#include "diagnostic-core.h"
#include "flags.h"
#include "tm-constrs.h"

#ifdef HAVE_peephole
extern rtx peep_operand[];

#define operands peep_operand

rtx_insn *
peephole (rtx_insn *ins1)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;
  rtx x ATTRIBUTE_UNUSED, pat ATTRIBUTE_UNUSED;

  if (NEXT_INSN (ins1)
      && BARRIER_P (NEXT_INSN (ins1)))
    return 0;

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2191;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! gpc_reg_operand (x, SImode)) goto L2191;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! scc_comparison_operator (x, SImode)) goto L2191;
  x = XEXP (XEXP (pat, 1), 0);
  operands[2] = x;
  if (! cc_reg_operand (x, VOIDmode)) goto L2191;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L2191;
  if (XWINT (x, 0) != 0) goto L2191;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2191; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2191;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2191;
  x = XEXP (pat, 0);
  operands[3] = x;
  if (! gpc_reg_operand (x, SImode)) goto L2191;
  x = XEXP (pat, 1);
  operands[4] = x;
  if (! scc_comparison_operator (x, SImode)) goto L2191;
  x = XEXP (XEXP (pat, 1), 0);
  operands[5] = x;
  if (! cc_reg_operand (x, VOIDmode)) goto L2191;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L2191;
  if (XWINT (x, 0) != 0) goto L2191;
  if (! (REGNO (operands[2]) != REGNO (operands[5]))) goto L2191;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (6, operands));
  INSN_CODE (ins1) = 2191;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2191:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2192;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! gpc_reg_operand (x, DImode)) goto L2192;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! scc_comparison_operator (x, DImode)) goto L2192;
  x = XEXP (XEXP (pat, 1), 0);
  operands[2] = x;
  if (! cc_reg_operand (x, VOIDmode)) goto L2192;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L2192;
  if (XWINT (x, 0) != 0) goto L2192;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2192; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2192;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2192;
  x = XEXP (pat, 0);
  operands[3] = x;
  if (! gpc_reg_operand (x, DImode)) goto L2192;
  x = XEXP (pat, 1);
  operands[4] = x;
  if (! scc_comparison_operator (x, DImode)) goto L2192;
  x = XEXP (XEXP (pat, 1), 0);
  operands[5] = x;
  if (! cc_reg_operand (x, VOIDmode)) goto L2192;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L2192;
  if (XWINT (x, 0) != 0) goto L2192;
  if (! (TARGET_POWERPC64 && REGNO (operands[2]) != REGNO (operands[5]))) goto L2192;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (6, operands));
  INSN_CODE (ins1) = 2192;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2192:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2717;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2717;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2717;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2717; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2717;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2717;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L2717;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2717;
  if (GET_MODE (x) != V16QImode) goto L2717;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2717;
  if (GET_MODE (x) != SImode) goto L2717;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2717;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2717;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_32BIT))) goto L2717;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2717;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2717:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2718;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2718;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2718;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2718; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2718;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2718;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L2718;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2718;
  if (GET_MODE (x) != V8HImode) goto L2718;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2718;
  if (GET_MODE (x) != SImode) goto L2718;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2718;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2718;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_32BIT))) goto L2718;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2718;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2718:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2719;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2719;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2719;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2719; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2719;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2719;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L2719;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2719;
  if (GET_MODE (x) != V4SImode) goto L2719;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2719;
  if (GET_MODE (x) != SImode) goto L2719;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2719;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2719;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_32BIT))) goto L2719;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2719;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2719:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2720;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2720;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2720;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2720; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2720;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2720;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L2720;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2720;
  if (GET_MODE (x) != V2DImode) goto L2720;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2720;
  if (GET_MODE (x) != SImode) goto L2720;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2720;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2720;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_32BIT))) goto L2720;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2720;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2720:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2721;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2721;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2721;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2721; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2721;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2721;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L2721;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2721;
  if (GET_MODE (x) != V4SFmode) goto L2721;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2721;
  if (GET_MODE (x) != SImode) goto L2721;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2721;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2721;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_32BIT))) goto L2721;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2721;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2721:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2722;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2722;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2722;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2722; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2722;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2722;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L2722;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2722;
  if (GET_MODE (x) != V2DFmode) goto L2722;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2722;
  if (GET_MODE (x) != SImode) goto L2722;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2722;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2722;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_32BIT))) goto L2722;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2722;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2722:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2723;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2723;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2723;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2723; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2723;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2723;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L2723;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2723;
  if (GET_MODE (x) != V1TImode) goto L2723;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2723;
  if (GET_MODE (x) != SImode) goto L2723;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2723;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2723;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_32BIT))) goto L2723;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2723;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2723:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2724;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2724;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2724;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2724; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2724;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2724;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L2724;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2724;
  if (GET_MODE (x) != TImode) goto L2724;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2724;
  if (GET_MODE (x) != SImode) goto L2724;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2724;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2724;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (((((TARGET_32BIT) && (TARGET_VSX_TIMODE)) && (TARGET_VSX_TIMODE)) && (TARGET_32BIT)) && (TARGET_32BIT)))) goto L2724;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2724;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2724:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2725;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2725;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2725;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2725; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2725;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2725;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L2725;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2725;
  if (GET_MODE (x) != V16QImode) goto L2725;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2725;
  if (GET_MODE (x) != DImode) goto L2725;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2725;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2725;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_64BIT))) goto L2725;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2725;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2725:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2726;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2726;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2726;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2726; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2726;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2726;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L2726;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2726;
  if (GET_MODE (x) != V8HImode) goto L2726;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2726;
  if (GET_MODE (x) != DImode) goto L2726;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2726;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2726;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_64BIT))) goto L2726;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2726;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2726:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2727;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2727;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2727;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2727; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2727;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2727;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L2727;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2727;
  if (GET_MODE (x) != V4SImode) goto L2727;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2727;
  if (GET_MODE (x) != DImode) goto L2727;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2727;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2727;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_64BIT))) goto L2727;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2727;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2727:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2728;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2728;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2728;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2728; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2728;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2728;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L2728;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2728;
  if (GET_MODE (x) != V2DImode) goto L2728;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2728;
  if (GET_MODE (x) != DImode) goto L2728;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2728;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2728;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_64BIT))) goto L2728;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2728;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2728:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2729;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2729;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2729;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2729; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2729;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2729;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L2729;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2729;
  if (GET_MODE (x) != V4SFmode) goto L2729;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2729;
  if (GET_MODE (x) != DImode) goto L2729;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2729;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2729;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_64BIT))) goto L2729;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2729;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2729:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2730;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2730;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2730;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2730; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2730;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2730;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L2730;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2730;
  if (GET_MODE (x) != V2DFmode) goto L2730;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2730;
  if (GET_MODE (x) != DImode) goto L2730;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2730;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2730;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_64BIT))) goto L2730;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2730;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2730:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2731;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2731;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2731;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2731; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2731;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2731;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L2731;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2731;
  if (GET_MODE (x) != V1TImode) goto L2731;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2731;
  if (GET_MODE (x) != DImode) goto L2731;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2731;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2731;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_64BIT))) goto L2731;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2731;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2731:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2732;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2732;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2732;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2732; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2732;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2732;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L2732;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2732;
  if (GET_MODE (x) != TImode) goto L2732;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2732;
  if (GET_MODE (x) != DImode) goto L2732;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2732;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2732;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (((((TARGET_64BIT) && (TARGET_VSX_TIMODE)) && (TARGET_VSX_TIMODE)) && (TARGET_64BIT)) && (TARGET_64BIT)))) goto L2732;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2732;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2732:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2733;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2733;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2733;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2733; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2733;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2733;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L2733;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2733;
  if (GET_MODE (x) != V16QImode) goto L2733;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2733;
  if (GET_MODE (x) != SImode) goto L2733;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2733;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2733;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_32BIT))) goto L2733;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2733;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2733:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2734;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2734;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2734;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2734; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2734;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2734;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L2734;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2734;
  if (GET_MODE (x) != V8HImode) goto L2734;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2734;
  if (GET_MODE (x) != SImode) goto L2734;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2734;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2734;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_32BIT))) goto L2734;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2734;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2734:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2735;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2735;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2735;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2735; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2735;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2735;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L2735;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2735;
  if (GET_MODE (x) != V4SImode) goto L2735;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2735;
  if (GET_MODE (x) != SImode) goto L2735;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2735;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2735;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_32BIT))) goto L2735;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2735;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2735:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2736;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2736;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2736;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2736; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2736;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2736;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L2736;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2736;
  if (GET_MODE (x) != V2DImode) goto L2736;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2736;
  if (GET_MODE (x) != SImode) goto L2736;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2736;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2736;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_32BIT))) goto L2736;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2736;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2736:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2737;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2737;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2737;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2737; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2737;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2737;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L2737;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2737;
  if (GET_MODE (x) != V4SFmode) goto L2737;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2737;
  if (GET_MODE (x) != SImode) goto L2737;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2737;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2737;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_32BIT))) goto L2737;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2737;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2737:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2738;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2738;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2738;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2738; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2738;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2738;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L2738;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2738;
  if (GET_MODE (x) != V2DFmode) goto L2738;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2738;
  if (GET_MODE (x) != SImode) goto L2738;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2738;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2738;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_32BIT))) goto L2738;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2738;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2738:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2739;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2739;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2739;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2739; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2739;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2739;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L2739;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2739;
  if (GET_MODE (x) != V1TImode) goto L2739;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2739;
  if (GET_MODE (x) != SImode) goto L2739;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2739;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2739;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_32BIT))) goto L2739;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2739;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2739:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2740;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2740;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2740;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2740; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2740;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2740;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L2740;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2740;
  if (GET_MODE (x) != TImode) goto L2740;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2740;
  if (GET_MODE (x) != SImode) goto L2740;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2740;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2740;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (((((TARGET_32BIT) && (TARGET_VSX_TIMODE)) && (TARGET_VSX_TIMODE)) && (TARGET_32BIT)) && (TARGET_32BIT)))) goto L2740;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2740;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2740:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2741;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2741;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2741;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2741; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2741;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2741;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L2741;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2741;
  if (GET_MODE (x) != V16QImode) goto L2741;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2741;
  if (GET_MODE (x) != DImode) goto L2741;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2741;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2741;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_64BIT))) goto L2741;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2741;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2741:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2742;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2742;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2742;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2742; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2742;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2742;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L2742;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2742;
  if (GET_MODE (x) != V8HImode) goto L2742;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2742;
  if (GET_MODE (x) != DImode) goto L2742;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2742;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2742;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_64BIT))) goto L2742;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2742;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2742:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2743;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2743;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2743;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2743; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2743;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2743;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L2743;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2743;
  if (GET_MODE (x) != V4SImode) goto L2743;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2743;
  if (GET_MODE (x) != DImode) goto L2743;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2743;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2743;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_64BIT))) goto L2743;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2743;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2743:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2744;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2744;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2744;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2744; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2744;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2744;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L2744;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2744;
  if (GET_MODE (x) != V2DImode) goto L2744;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2744;
  if (GET_MODE (x) != DImode) goto L2744;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2744;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2744;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_64BIT))) goto L2744;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2744;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2744:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2745;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2745;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2745;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2745; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2745;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2745;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L2745;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2745;
  if (GET_MODE (x) != V4SFmode) goto L2745;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2745;
  if (GET_MODE (x) != DImode) goto L2745;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2745;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2745;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_64BIT))) goto L2745;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2745;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2745:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2746;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2746;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2746;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2746; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2746;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2746;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L2746;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2746;
  if (GET_MODE (x) != V2DFmode) goto L2746;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2746;
  if (GET_MODE (x) != DImode) goto L2746;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2746;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2746;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_64BIT))) goto L2746;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2746;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2746:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2747;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2747;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2747;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2747; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2747;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2747;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L2747;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2747;
  if (GET_MODE (x) != V1TImode) goto L2747;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2747;
  if (GET_MODE (x) != DImode) goto L2747;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2747;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2747;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (TARGET_64BIT))) goto L2747;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2747;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2747:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2748;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2748;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2748;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2748; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2748;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2748;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L2748;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2748;
  if (GET_MODE (x) != TImode) goto L2748;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2748;
  if (GET_MODE (x) != DImode) goto L2748;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2748;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L2748;
  if (! ((TARGET_VSX && TARGET_P8_FUSION) && (((((TARGET_64BIT) && (TARGET_VSX_TIMODE)) && (TARGET_VSX_TIMODE)) && (TARGET_64BIT)) && (TARGET_64BIT)))) goto L2748;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2748;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2748:

  return 0;
}

rtx peep_operand[6];
#endif
