/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "hash-set.h"
#include "machmode.h"
#include "vec.h"
#include "double-int.h"
#include "input.h"
#include "alias.h"
#include "symtab.h"
#include "wide-int.h"
#include "inchash.h"
#include "tree.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "rtl.h"
#include "predict.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "hashtab.h"
#include "hard-reg-set.h"
#include "function.h"
#include "statistics.h"
#include "real.h"
#include "fixed-value.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x010708, CODE_FOR_extendqihi2 },
  { 0x010709, CODE_FOR_extendqisi2 },
  { 0x01070a, CODE_FOR_extendqidi2 },
  { 0x010809, CODE_FOR_extendhisi2 },
  { 0x01080a, CODE_FOR_extendhidi2 },
  { 0x01090a, CODE_FOR_extendsidi2 },
  { 0x011f20, CODE_FOR_extendsfdf2 },
  { 0x011f21, CODE_FOR_extendsftf2 },
  { 0x012021, CODE_FOR_extenddftf2 },
  { 0x012223, CODE_FOR_extendsddd2 },
  { 0x012224, CODE_FOR_extendsdtd2 },
  { 0x012324, CODE_FOR_extendddtd2 },
  { 0x02201f, CODE_FOR_truncdfsf2 },
  { 0x02211f, CODE_FOR_trunctfsf2 },
  { 0x022120, CODE_FOR_trunctfdf2 },
  { 0x022322, CODE_FOR_truncddsd2 },
  { 0x022423, CODE_FOR_trunctddd2 },
  { 0x030708, CODE_FOR_zero_extendqihi2 },
  { 0x030709, CODE_FOR_zero_extendqisi2 },
  { 0x03070a, CODE_FOR_zero_extendqidi2 },
  { 0x030809, CODE_FOR_zero_extendhisi2 },
  { 0x03080a, CODE_FOR_zero_extendhidi2 },
  { 0x03090a, CODE_FOR_zero_extendsidi2 },
  { 0x04230a, CODE_FOR_fixdddi2 },
  { 0x04240a, CODE_FOR_fixtddi2 },
  { 0x06091f, CODE_FOR_floatsisf2 },
  { 0x060920, CODE_FOR_floatsidf2 },
  { 0x060921, CODE_FOR_floatsitf2 },
  { 0x060a1f, CODE_FOR_floatdisf2 },
  { 0x060a20, CODE_FOR_floatdidf2 },
  { 0x060a23, CODE_FOR_floatdidd2 },
  { 0x060a24, CODE_FOR_floatditd2 },
  { 0x06333c, CODE_FOR_floatv4siv4sf2 },
  { 0x06343d, CODE_FOR_floatv2div2df2 },
  { 0x07091f, CODE_FOR_floatunssisf2 },
  { 0x070920, CODE_FOR_floatunssidf2 },
  { 0x070a1f, CODE_FOR_floatunsdisf2 },
  { 0x070a20, CODE_FOR_floatunsdidf2 },
  { 0x07333c, CODE_FOR_floatunsv4siv4sf2 },
  { 0x07343d, CODE_FOR_floatunsv2div2df2 },
  { 0x081f0a, CODE_FOR_lrintsfdi2 },
  { 0x08200a, CODE_FOR_lrintdfdi2 },
  { 0x091f0a, CODE_FOR_lroundsfdi2 },
  { 0x09200a, CODE_FOR_lrounddfdi2 },
  { 0x101f09, CODE_FOR_fix_truncsfsi2 },
  { 0x101f0a, CODE_FOR_fix_truncsfdi2 },
  { 0x102009, CODE_FOR_fix_truncdfsi2 },
  { 0x10200a, CODE_FOR_fix_truncdfdi2 },
  { 0x102109, CODE_FOR_fix_trunctfsi2 },
  { 0x103c33, CODE_FOR_fix_truncv4sfv4si2 },
  { 0x103d34, CODE_FOR_fix_truncv2dfv2di2 },
  { 0x111f09, CODE_FOR_fixuns_truncsfsi2 },
  { 0x111f0a, CODE_FOR_fixuns_truncsfdi2 },
  { 0x112009, CODE_FOR_fixuns_truncdfsi2 },
  { 0x11200a, CODE_FOR_fixuns_truncdfdi2 },
  { 0x113c33, CODE_FOR_fixuns_truncv4sfv4si2 },
  { 0x113d34, CODE_FOR_fixuns_truncv2dfv2di2 },
  { 0x12090a, CODE_FOR_mulsidi3 },
  { 0x120a0b, CODE_FOR_mulditi3 },
  { 0x13090a, CODE_FOR_umulsidi3 },
  { 0x130a0b, CODE_FOR_umulditi3 },
  { 0x1f3131, CODE_FOR_vcondv16qiv16qi },
  { 0x1f3232, CODE_FOR_vcondv8hiv8hi },
  { 0x1f3333, CODE_FOR_vcondv4siv4si },
  { 0x1f333c, CODE_FOR_vcondv4sfv4si },
  { 0x1f3434, CODE_FOR_vcondv2div2di },
  { 0x1f3c33, CODE_FOR_vcondv4siv4sf },
  { 0x1f3c3c, CODE_FOR_vcondv4sfv4sf },
  { 0x1f3d3d, CODE_FOR_vcondv2dfv2df },
  { 0x203131, CODE_FOR_vconduv16qiv16qi },
  { 0x203232, CODE_FOR_vconduv8hiv8hi },
  { 0x203333, CODE_FOR_vconduv4siv4si },
  { 0x20333c, CODE_FOR_vconduv4sfv4si },
  { 0x203434, CODE_FOR_vconduv2div2di },
  { 0x210009, CODE_FOR_addsi3 },
  { 0x21000a, CODE_FOR_adddi3 },
  { 0x21000b, CODE_FOR_addti3 },
  { 0x21001f, CODE_FOR_addsf3 },
  { 0x210020, CODE_FOR_adddf3 },
  { 0x210023, CODE_FOR_adddd3 },
  { 0x210024, CODE_FOR_addtd3 },
  { 0x210031, CODE_FOR_addv16qi3 },
  { 0x210032, CODE_FOR_addv8hi3 },
  { 0x210033, CODE_FOR_addv4si3 },
  { 0x210034, CODE_FOR_addv2di3 },
  { 0x21003c, CODE_FOR_addv4sf3 },
  { 0x21003d, CODE_FOR_addv2df3 },
  { 0x250009, CODE_FOR_subsi3 },
  { 0x25000a, CODE_FOR_subdi3 },
  { 0x25000b, CODE_FOR_subti3 },
  { 0x25001f, CODE_FOR_subsf3 },
  { 0x250020, CODE_FOR_subdf3 },
  { 0x250023, CODE_FOR_subdd3 },
  { 0x250024, CODE_FOR_subtd3 },
  { 0x250031, CODE_FOR_subv16qi3 },
  { 0x250032, CODE_FOR_subv8hi3 },
  { 0x250033, CODE_FOR_subv4si3 },
  { 0x250034, CODE_FOR_subv2di3 },
  { 0x25003c, CODE_FOR_subv4sf3 },
  { 0x25003d, CODE_FOR_subv2df3 },
  { 0x290009, CODE_FOR_mulsi3 },
  { 0x29000a, CODE_FOR_muldi3 },
  { 0x29001f, CODE_FOR_mulsf3 },
  { 0x290020, CODE_FOR_muldf3 },
  { 0x290023, CODE_FOR_muldd3 },
  { 0x290024, CODE_FOR_multd3 },
  { 0x290032, CODE_FOR_mulv8hi3 },
  { 0x290033, CODE_FOR_mulv4si3 },
  { 0x29003c, CODE_FOR_mulv4sf3 },
  { 0x29003d, CODE_FOR_mulv2df3 },
  { 0x2d0009, CODE_FOR_divsi3 },
  { 0x2d000a, CODE_FOR_divdi3 },
  { 0x2d001f, CODE_FOR_divsf3 },
  { 0x2d0020, CODE_FOR_divdf3 },
  { 0x2d0023, CODE_FOR_divdd3 },
  { 0x2d0024, CODE_FOR_divtd3 },
  { 0x2d003c, CODE_FOR_divv4sf3 },
  { 0x2d003d, CODE_FOR_divv2df3 },
  { 0x300009, CODE_FOR_udivsi3 },
  { 0x30000a, CODE_FOR_udivdi3 },
  { 0x340009, CODE_FOR_modsi3 },
  { 0x34000a, CODE_FOR_moddi3 },
  { 0x360023, CODE_FOR_ftruncdd2 },
  { 0x360024, CODE_FOR_ftrunctd2 },
  { 0x36003c, CODE_FOR_ftruncv4sf2 },
  { 0x36003d, CODE_FOR_ftruncv2df2 },
  { 0x370009, CODE_FOR_andsi3 },
  { 0x37000a, CODE_FOR_anddi3 },
  { 0x37000b, CODE_FOR_andti3 },
  { 0x37000c, CODE_FOR_andpti3 },
  { 0x370029, CODE_FOR_andcti3 },
  { 0x370031, CODE_FOR_andv16qi3 },
  { 0x370032, CODE_FOR_andv8hi3 },
  { 0x370033, CODE_FOR_andv4si3 },
  { 0x370034, CODE_FOR_andv2di3 },
  { 0x370035, CODE_FOR_andv1ti3 },
  { 0x37003c, CODE_FOR_andv4sf3 },
  { 0x37003d, CODE_FOR_andv2df3 },
  { 0x380009, CODE_FOR_iorsi3 },
  { 0x38000a, CODE_FOR_iordi3 },
  { 0x38000b, CODE_FOR_iorti3 },
  { 0x38000c, CODE_FOR_iorpti3 },
  { 0x380031, CODE_FOR_iorv16qi3 },
  { 0x380032, CODE_FOR_iorv8hi3 },
  { 0x380033, CODE_FOR_iorv4si3 },
  { 0x380034, CODE_FOR_iorv2di3 },
  { 0x380035, CODE_FOR_iorv1ti3 },
  { 0x38003c, CODE_FOR_iorv4sf3 },
  { 0x38003d, CODE_FOR_iorv2df3 },
  { 0x390009, CODE_FOR_xorsi3 },
  { 0x39000a, CODE_FOR_xordi3 },
  { 0x39000b, CODE_FOR_xorti3 },
  { 0x39000c, CODE_FOR_xorpti3 },
  { 0x390031, CODE_FOR_xorv16qi3 },
  { 0x390032, CODE_FOR_xorv8hi3 },
  { 0x390033, CODE_FOR_xorv4si3 },
  { 0x390034, CODE_FOR_xorv2di3 },
  { 0x390035, CODE_FOR_xorv1ti3 },
  { 0x39003c, CODE_FOR_xorv4sf3 },
  { 0x39003d, CODE_FOR_xorv2df3 },
  { 0x3a0009, CODE_FOR_ashlsi3 },
  { 0x3a000a, CODE_FOR_ashldi3 },
  { 0x3d0009, CODE_FOR_ashrsi3 },
  { 0x3d000a, CODE_FOR_ashrdi3 },
  { 0x3e0009, CODE_FOR_lshrsi3 },
  { 0x3e000a, CODE_FOR_lshrdi3 },
  { 0x3f0009, CODE_FOR_rotlsi3 },
  { 0x3f000a, CODE_FOR_rotldi3 },
  { 0x410031, CODE_FOR_vashlv16qi3 },
  { 0x410032, CODE_FOR_vashlv8hi3 },
  { 0x410033, CODE_FOR_vashlv4si3 },
  { 0x410034, CODE_FOR_vashlv2di3 },
  { 0x420031, CODE_FOR_vashrv16qi3 },
  { 0x420032, CODE_FOR_vashrv8hi3 },
  { 0x420033, CODE_FOR_vashrv4si3 },
  { 0x420034, CODE_FOR_vashrv2di3 },
  { 0x430031, CODE_FOR_vlshrv16qi3 },
  { 0x430032, CODE_FOR_vlshrv8hi3 },
  { 0x430033, CODE_FOR_vlshrv4si3 },
  { 0x430034, CODE_FOR_vlshrv2di3 },
  { 0x440031, CODE_FOR_vrotlv16qi3 },
  { 0x440032, CODE_FOR_vrotlv8hi3 },
  { 0x440033, CODE_FOR_vrotlv4si3 },
  { 0x440034, CODE_FOR_vrotlv2di3 },
  { 0x46001f, CODE_FOR_sminsf3 },
  { 0x460020, CODE_FOR_smindf3 },
  { 0x460031, CODE_FOR_sminv16qi3 },
  { 0x460032, CODE_FOR_sminv8hi3 },
  { 0x460033, CODE_FOR_sminv4si3 },
  { 0x460034, CODE_FOR_sminv2di3 },
  { 0x46003c, CODE_FOR_sminv4sf3 },
  { 0x46003d, CODE_FOR_sminv2df3 },
  { 0x47001f, CODE_FOR_smaxsf3 },
  { 0x470020, CODE_FOR_smaxdf3 },
  { 0x470031, CODE_FOR_smaxv16qi3 },
  { 0x470032, CODE_FOR_smaxv8hi3 },
  { 0x470033, CODE_FOR_smaxv4si3 },
  { 0x470034, CODE_FOR_smaxv2di3 },
  { 0x47003c, CODE_FOR_smaxv4sf3 },
  { 0x47003d, CODE_FOR_smaxv2df3 },
  { 0x480031, CODE_FOR_uminv16qi3 },
  { 0x480032, CODE_FOR_uminv8hi3 },
  { 0x480033, CODE_FOR_uminv4si3 },
  { 0x480034, CODE_FOR_uminv2di3 },
  { 0x490031, CODE_FOR_umaxv16qi3 },
  { 0x490032, CODE_FOR_umaxv8hi3 },
  { 0x490033, CODE_FOR_umaxv4si3 },
  { 0x490034, CODE_FOR_umaxv2di3 },
  { 0x4a0009, CODE_FOR_negsi2 },
  { 0x4a000a, CODE_FOR_negdi2 },
  { 0x4a001f, CODE_FOR_negsf2 },
  { 0x4a0020, CODE_FOR_negdf2 },
  { 0x4a0021, CODE_FOR_negtf2 },
  { 0x4a0023, CODE_FOR_negdd2 },
  { 0x4a0024, CODE_FOR_negtd2 },
  { 0x4a0031, CODE_FOR_negv16qi2 },
  { 0x4a0032, CODE_FOR_negv8hi2 },
  { 0x4a0033, CODE_FOR_negv4si2 },
  { 0x4a003c, CODE_FOR_negv4sf2 },
  { 0x4a003d, CODE_FOR_negv2df2 },
  { 0x4e001f, CODE_FOR_abssf2 },
  { 0x4e0020, CODE_FOR_absdf2 },
  { 0x4e0021, CODE_FOR_abstf2 },
  { 0x4e0023, CODE_FOR_absdd2 },
  { 0x4e0024, CODE_FOR_abstd2 },
  { 0x4e0031, CODE_FOR_absv16qi2 },
  { 0x4e0032, CODE_FOR_absv8hi2 },
  { 0x4e0033, CODE_FOR_absv4si2 },
  { 0x4e0034, CODE_FOR_absv2di2 },
  { 0x4e003c, CODE_FOR_absv4sf2 },
  { 0x4e003d, CODE_FOR_absv2df2 },
  { 0x500009, CODE_FOR_one_cmplsi2 },
  { 0x50000a, CODE_FOR_one_cmpldi2 },
  { 0x50000b, CODE_FOR_one_cmplti2 },
  { 0x50000c, CODE_FOR_one_cmplpti2 },
  { 0x500031, CODE_FOR_one_cmplv16qi2 },
  { 0x500032, CODE_FOR_one_cmplv8hi2 },
  { 0x500033, CODE_FOR_one_cmplv4si2 },
  { 0x500034, CODE_FOR_one_cmplv2di2 },
  { 0x500035, CODE_FOR_one_cmplv1ti2 },
  { 0x50003c, CODE_FOR_one_cmplv4sf2 },
  { 0x50003d, CODE_FOR_one_cmplv2df2 },
  { 0x510008, CODE_FOR_bswaphi2 },
  { 0x510009, CODE_FOR_bswapsi2 },
  { 0x51000a, CODE_FOR_bswapdi2 },
  { 0x520009, CODE_FOR_ffssi2 },
  { 0x52000a, CODE_FOR_ffsdi2 },
  { 0x530009, CODE_FOR_clzsi2 },
  { 0x53000a, CODE_FOR_clzdi2 },
  { 0x530031, CODE_FOR_clzv16qi2 },
  { 0x530032, CODE_FOR_clzv8hi2 },
  { 0x530033, CODE_FOR_clzv4si2 },
  { 0x530034, CODE_FOR_clzv2di2 },
  { 0x540009, CODE_FOR_ctzsi2 },
  { 0x54000a, CODE_FOR_ctzdi2 },
  { 0x560009, CODE_FOR_popcountsi2 },
  { 0x56000a, CODE_FOR_popcountdi2 },
  { 0x560031, CODE_FOR_popcountv16qi2 },
  { 0x560032, CODE_FOR_popcountv8hi2 },
  { 0x560033, CODE_FOR_popcountv4si2 },
  { 0x560034, CODE_FOR_popcountv2di2 },
  { 0x570009, CODE_FOR_paritysi2 },
  { 0x57000a, CODE_FOR_paritydi2 },
  { 0x62001f, CODE_FOR_sqrtsf2 },
  { 0x620020, CODE_FOR_sqrtdf2 },
  { 0x62003c, CODE_FOR_sqrtv4sf2 },
  { 0x62003d, CODE_FOR_sqrtv2df2 },
  { 0x710002, CODE_FOR_movcc },
  { 0x710007, CODE_FOR_movqi },
  { 0x710008, CODE_FOR_movhi },
  { 0x710009, CODE_FOR_movsi },
  { 0x71000a, CODE_FOR_movdi },
  { 0x71000b, CODE_FOR_movti },
  { 0x71000c, CODE_FOR_movpti },
  { 0x71001f, CODE_FOR_movsf },
  { 0x710020, CODE_FOR_movdf },
  { 0x710021, CODE_FOR_movtf },
  { 0x710022, CODE_FOR_movsd },
  { 0x710023, CODE_FOR_movdd },
  { 0x710024, CODE_FOR_movtd },
  { 0x710031, CODE_FOR_movv16qi },
  { 0x710032, CODE_FOR_movv8hi },
  { 0x710033, CODE_FOR_movv4si },
  { 0x710034, CODE_FOR_movv2di },
  { 0x710035, CODE_FOR_movv1ti },
  { 0x71003c, CODE_FOR_movv4sf },
  { 0x71003d, CODE_FOR_movv2df },
  { 0x730033, CODE_FOR_movmisalignv4si },
  { 0x730034, CODE_FOR_movmisalignv2di },
  { 0x730035, CODE_FOR_movmisalignv1ti },
  { 0x73003c, CODE_FOR_movmisalignv4sf },
  { 0x73003d, CODE_FOR_movmisalignv2df },
  { 0x7e0009, CODE_FOR_cbranchsi4 },
  { 0x7e000a, CODE_FOR_cbranchdi4 },
  { 0x7e001f, CODE_FOR_cbranchsf4 },
  { 0x7e0020, CODE_FOR_cbranchdf4 },
  { 0x7e0021, CODE_FOR_cbranchtf4 },
  { 0x7e0023, CODE_FOR_cbranchdd4 },
  { 0x7e0024, CODE_FOR_cbranchtd4 },
  { 0x800009, CODE_FOR_movsicc },
  { 0x80000a, CODE_FOR_movdicc },
  { 0x80001f, CODE_FOR_movsfcc },
  { 0x800020, CODE_FOR_movdfcc },
  { 0x820009, CODE_FOR_cstoresi4 },
  { 0x82000a, CODE_FOR_cstoredi4 },
  { 0x82001f, CODE_FOR_cstoresf4 },
  { 0x820020, CODE_FOR_cstoredf4 },
  { 0x820021, CODE_FOR_cstoretf4 },
  { 0x820023, CODE_FOR_cstoredd4 },
  { 0x820024, CODE_FOR_cstoretd4 },
  { 0x830009, CODE_FOR_ctrapsi4 },
  { 0x83000a, CODE_FOR_ctrapdi4 },
  { 0x8a0009, CODE_FOR_smulsi3_highpart },
  { 0x8a000a, CODE_FOR_smuldi3_highpart },
  { 0x8b0009, CODE_FOR_umulsi3_highpart },
  { 0x8b000a, CODE_FOR_umuldi3_highpart },
  { 0x8f0009, CODE_FOR_movmemsi },
  { 0x900009, CODE_FOR_setmemsi },
  { 0x910009, CODE_FOR_strlensi },
  { 0x92001f, CODE_FOR_fmasf4 },
  { 0x920020, CODE_FOR_fmadf4 },
  { 0x92003c, CODE_FOR_fmav4sf4 },
  { 0x92003d, CODE_FOR_fmav2df4 },
  { 0x93001f, CODE_FOR_fmssf4 },
  { 0x930020, CODE_FOR_fmsdf4 },
  { 0x93003c, CODE_FOR_fmsv4sf4 },
  { 0x93003d, CODE_FOR_fmsv2df4 },
  { 0x94001f, CODE_FOR_fnmasf4 },
  { 0x940020, CODE_FOR_fnmadf4 },
  { 0x94003b, CODE_FOR_fnmav2sf4 },
  { 0x94003c, CODE_FOR_fnmav4sf4 },
  { 0x94003d, CODE_FOR_fnmav2df4 },
  { 0x95001f, CODE_FOR_fnmssf4 },
  { 0x950020, CODE_FOR_fnmsdf4 },
  { 0x95003b, CODE_FOR_fnmsv2sf4 },
  { 0x95003c, CODE_FOR_fnmsv4sf4 },
  { 0x95003d, CODE_FOR_fnmsv2df4 },
  { 0x97001f, CODE_FOR_roundsf2 },
  { 0x970020, CODE_FOR_rounddf2 },
  { 0x98001f, CODE_FOR_floorsf2 },
  { 0x980020, CODE_FOR_floordf2 },
  { 0x99001f, CODE_FOR_ceilsf2 },
  { 0x990020, CODE_FOR_ceildf2 },
  { 0x9a001f, CODE_FOR_btruncsf2 },
  { 0x9a0020, CODE_FOR_btruncdf2 },
  { 0xa0001f, CODE_FOR_copysignsf3 },
  { 0xa00020, CODE_FOR_copysigndf3 },
  { 0xb20021, CODE_FOR_signbittf2 },
  { 0xbc003c, CODE_FOR_reduc_smax_v4sf },
  { 0xbc003d, CODE_FOR_reduc_smax_v2df },
  { 0xbd003c, CODE_FOR_reduc_smin_v4sf },
  { 0xbd003d, CODE_FOR_reduc_smin_v2df },
  { 0xbe0031, CODE_FOR_reduc_splus_v16qi },
  { 0xbe0032, CODE_FOR_reduc_splus_v8hi },
  { 0xbe003c, CODE_FOR_reduc_splus_v4sf },
  { 0xbe003d, CODE_FOR_reduc_splus_v2df },
  { 0xc10031, CODE_FOR_reduc_uplus_v16qi },
  { 0xc20032, CODE_FOR_sdot_prodv8hi },
  { 0xc30031, CODE_FOR_widen_ssumv16qi3 },
  { 0xc30032, CODE_FOR_widen_ssumv8hi3 },
  { 0xc40031, CODE_FOR_udot_prodv16qi },
  { 0xc40032, CODE_FOR_udot_prodv8hi },
  { 0xc50031, CODE_FOR_widen_usumv16qi3 },
  { 0xc50032, CODE_FOR_widen_usumv8hi3 },
  { 0xca0031, CODE_FOR_vec_extractv16qi },
  { 0xca0032, CODE_FOR_vec_extractv8hi },
  { 0xca0033, CODE_FOR_vec_extractv4si },
  { 0xca0034, CODE_FOR_vec_extractv2di },
  { 0xca003c, CODE_FOR_vec_extractv4sf },
  { 0xca003d, CODE_FOR_vec_extractv2df },
  { 0xcb0031, CODE_FOR_vec_initv16qi },
  { 0xcb0032, CODE_FOR_vec_initv8hi },
  { 0xcb0033, CODE_FOR_vec_initv4si },
  { 0xcb0034, CODE_FOR_vec_initv2di },
  { 0xcb003c, CODE_FOR_vec_initv4sf },
  { 0xcb003d, CODE_FOR_vec_initv2df },
  { 0xcc003d, CODE_FOR_vec_pack_sfix_trunc_v2df },
  { 0xce0032, CODE_FOR_vec_pack_trunc_v8hi },
  { 0xce0033, CODE_FOR_vec_pack_trunc_v4si },
  { 0xce0034, CODE_FOR_vec_pack_trunc_v2di },
  { 0xce003d, CODE_FOR_vec_pack_trunc_v2df },
  { 0xcf003d, CODE_FOR_vec_pack_ufix_trunc_v2df },
  { 0xd10031, CODE_FOR_vec_perm_constv16qi },
  { 0xd10034, CODE_FOR_vec_perm_constv2di },
  { 0xd1003d, CODE_FOR_vec_perm_constv2df },
  { 0xd20031, CODE_FOR_vec_permv16qi },
  { 0xd30031, CODE_FOR_vec_realign_load_v16qi },
  { 0xd30032, CODE_FOR_vec_realign_load_v8hi },
  { 0xd30033, CODE_FOR_vec_realign_load_v4si },
  { 0xd3003c, CODE_FOR_vec_realign_load_v4sf },
  { 0xd40031, CODE_FOR_vec_setv16qi },
  { 0xd40032, CODE_FOR_vec_setv8hi },
  { 0xd40033, CODE_FOR_vec_setv4si },
  { 0xd40034, CODE_FOR_vec_setv2di },
  { 0xd4003c, CODE_FOR_vec_setv4sf },
  { 0xd4003d, CODE_FOR_vec_setv2df },
  { 0xd5000b, CODE_FOR_vec_shr_ti },
  { 0xd50031, CODE_FOR_vec_shr_v16qi },
  { 0xd50032, CODE_FOR_vec_shr_v8hi },
  { 0xd50033, CODE_FOR_vec_shr_v4si },
  { 0xd50034, CODE_FOR_vec_shr_v2di },
  { 0xd50035, CODE_FOR_vec_shr_v1ti },
  { 0xd5003c, CODE_FOR_vec_shr_v4sf },
  { 0xd5003d, CODE_FOR_vec_shr_v2df },
  { 0xd60032, CODE_FOR_vec_unpacks_float_hi_v8hi },
  { 0xd60033, CODE_FOR_vec_unpacks_float_hi_v4si },
  { 0xd70032, CODE_FOR_vec_unpacks_float_lo_v8hi },
  { 0xd70033, CODE_FOR_vec_unpacks_float_lo_v4si },
  { 0xd80031, CODE_FOR_vec_unpacks_hi_v16qi },
  { 0xd80032, CODE_FOR_vec_unpacks_hi_v8hi },
  { 0xd80033, CODE_FOR_vec_unpacks_hi_v4si },
  { 0xd8003c, CODE_FOR_vec_unpacks_hi_v4sf },
  { 0xd90031, CODE_FOR_vec_unpacks_lo_v16qi },
  { 0xd90032, CODE_FOR_vec_unpacks_lo_v8hi },
  { 0xd90033, CODE_FOR_vec_unpacks_lo_v4si },
  { 0xd9003c, CODE_FOR_vec_unpacks_lo_v4sf },
  { 0xda0032, CODE_FOR_vec_unpacku_float_hi_v8hi },
  { 0xda0033, CODE_FOR_vec_unpacku_float_hi_v4si },
  { 0xdb0032, CODE_FOR_vec_unpacku_float_lo_v8hi },
  { 0xdb0033, CODE_FOR_vec_unpacku_float_lo_v4si },
  { 0xdc0031, CODE_FOR_vec_unpacku_hi_v16qi },
  { 0xdc0032, CODE_FOR_vec_unpacku_hi_v8hi },
  { 0xdd0031, CODE_FOR_vec_unpacku_lo_v16qi },
  { 0xdd0032, CODE_FOR_vec_unpacku_lo_v8hi },
  { 0xde0031, CODE_FOR_vec_widen_smult_even_v16qi },
  { 0xde0032, CODE_FOR_vec_widen_smult_even_v8hi },
  { 0xdf0031, CODE_FOR_vec_widen_smult_hi_v16qi },
  { 0xdf0032, CODE_FOR_vec_widen_smult_hi_v8hi },
  { 0xe00031, CODE_FOR_vec_widen_smult_lo_v16qi },
  { 0xe00032, CODE_FOR_vec_widen_smult_lo_v8hi },
  { 0xe10031, CODE_FOR_vec_widen_smult_odd_v16qi },
  { 0xe10032, CODE_FOR_vec_widen_smult_odd_v8hi },
  { 0xe40031, CODE_FOR_vec_widen_umult_even_v16qi },
  { 0xe40032, CODE_FOR_vec_widen_umult_even_v8hi },
  { 0xe50031, CODE_FOR_vec_widen_umult_hi_v16qi },
  { 0xe50032, CODE_FOR_vec_widen_umult_hi_v8hi },
  { 0xe60031, CODE_FOR_vec_widen_umult_lo_v16qi },
  { 0xe60032, CODE_FOR_vec_widen_umult_lo_v8hi },
  { 0xe70031, CODE_FOR_vec_widen_umult_odd_v16qi },
  { 0xe70032, CODE_FOR_vec_widen_umult_odd_v8hi },
  { 0xf10007, CODE_FOR_atomic_add_fetchqi },
  { 0xf10008, CODE_FOR_atomic_add_fetchhi },
  { 0xf10009, CODE_FOR_atomic_add_fetchsi },
  { 0xf1000a, CODE_FOR_atomic_add_fetchdi },
  { 0xf1000b, CODE_FOR_atomic_add_fetchti },
  { 0xf20007, CODE_FOR_atomic_addqi },
  { 0xf20008, CODE_FOR_atomic_addhi },
  { 0xf20009, CODE_FOR_atomic_addsi },
  { 0xf2000a, CODE_FOR_atomic_adddi },
  { 0xf2000b, CODE_FOR_atomic_addti },
  { 0xf30007, CODE_FOR_atomic_and_fetchqi },
  { 0xf30008, CODE_FOR_atomic_and_fetchhi },
  { 0xf30009, CODE_FOR_atomic_and_fetchsi },
  { 0xf3000a, CODE_FOR_atomic_and_fetchdi },
  { 0xf3000b, CODE_FOR_atomic_and_fetchti },
  { 0xf40007, CODE_FOR_atomic_andqi },
  { 0xf40008, CODE_FOR_atomic_andhi },
  { 0xf40009, CODE_FOR_atomic_andsi },
  { 0xf4000a, CODE_FOR_atomic_anddi },
  { 0xf4000b, CODE_FOR_atomic_andti },
  { 0xf50007, CODE_FOR_atomic_compare_and_swapqi },
  { 0xf50008, CODE_FOR_atomic_compare_and_swaphi },
  { 0xf50009, CODE_FOR_atomic_compare_and_swapsi },
  { 0xf5000a, CODE_FOR_atomic_compare_and_swapdi },
  { 0xf5000b, CODE_FOR_atomic_compare_and_swapti },
  { 0xf60007, CODE_FOR_atomic_exchangeqi },
  { 0xf60008, CODE_FOR_atomic_exchangehi },
  { 0xf60009, CODE_FOR_atomic_exchangesi },
  { 0xf6000a, CODE_FOR_atomic_exchangedi },
  { 0xf6000b, CODE_FOR_atomic_exchangeti },
  { 0xf70007, CODE_FOR_atomic_fetch_addqi },
  { 0xf70008, CODE_FOR_atomic_fetch_addhi },
  { 0xf70009, CODE_FOR_atomic_fetch_addsi },
  { 0xf7000a, CODE_FOR_atomic_fetch_adddi },
  { 0xf7000b, CODE_FOR_atomic_fetch_addti },
  { 0xf80007, CODE_FOR_atomic_fetch_andqi },
  { 0xf80008, CODE_FOR_atomic_fetch_andhi },
  { 0xf80009, CODE_FOR_atomic_fetch_andsi },
  { 0xf8000a, CODE_FOR_atomic_fetch_anddi },
  { 0xf8000b, CODE_FOR_atomic_fetch_andti },
  { 0xf90007, CODE_FOR_atomic_fetch_nandqi },
  { 0xf90008, CODE_FOR_atomic_fetch_nandhi },
  { 0xf90009, CODE_FOR_atomic_fetch_nandsi },
  { 0xf9000a, CODE_FOR_atomic_fetch_nanddi },
  { 0xf9000b, CODE_FOR_atomic_fetch_nandti },
  { 0xfa0007, CODE_FOR_atomic_fetch_orqi },
  { 0xfa0008, CODE_FOR_atomic_fetch_orhi },
  { 0xfa0009, CODE_FOR_atomic_fetch_orsi },
  { 0xfa000a, CODE_FOR_atomic_fetch_ordi },
  { 0xfa000b, CODE_FOR_atomic_fetch_orti },
  { 0xfb0007, CODE_FOR_atomic_fetch_subqi },
  { 0xfb0008, CODE_FOR_atomic_fetch_subhi },
  { 0xfb0009, CODE_FOR_atomic_fetch_subsi },
  { 0xfb000a, CODE_FOR_atomic_fetch_subdi },
  { 0xfb000b, CODE_FOR_atomic_fetch_subti },
  { 0xfc0007, CODE_FOR_atomic_fetch_xorqi },
  { 0xfc0008, CODE_FOR_atomic_fetch_xorhi },
  { 0xfc0009, CODE_FOR_atomic_fetch_xorsi },
  { 0xfc000a, CODE_FOR_atomic_fetch_xordi },
  { 0xfc000b, CODE_FOR_atomic_fetch_xorti },
  { 0xfd0007, CODE_FOR_atomic_loadqi },
  { 0xfd0008, CODE_FOR_atomic_loadhi },
  { 0xfd0009, CODE_FOR_atomic_loadsi },
  { 0xfd000a, CODE_FOR_atomic_loaddi },
  { 0xfd000b, CODE_FOR_atomic_loadti },
  { 0xfe0007, CODE_FOR_atomic_nand_fetchqi },
  { 0xfe0008, CODE_FOR_atomic_nand_fetchhi },
  { 0xfe0009, CODE_FOR_atomic_nand_fetchsi },
  { 0xfe000a, CODE_FOR_atomic_nand_fetchdi },
  { 0xfe000b, CODE_FOR_atomic_nand_fetchti },
  { 0xff0007, CODE_FOR_atomic_nandqi },
  { 0xff0008, CODE_FOR_atomic_nandhi },
  { 0xff0009, CODE_FOR_atomic_nandsi },
  { 0xff000a, CODE_FOR_atomic_nanddi },
  { 0xff000b, CODE_FOR_atomic_nandti },
  { 0x1000007, CODE_FOR_atomic_or_fetchqi },
  { 0x1000008, CODE_FOR_atomic_or_fetchhi },
  { 0x1000009, CODE_FOR_atomic_or_fetchsi },
  { 0x100000a, CODE_FOR_atomic_or_fetchdi },
  { 0x100000b, CODE_FOR_atomic_or_fetchti },
  { 0x1010007, CODE_FOR_atomic_orqi },
  { 0x1010008, CODE_FOR_atomic_orhi },
  { 0x1010009, CODE_FOR_atomic_orsi },
  { 0x101000a, CODE_FOR_atomic_ordi },
  { 0x101000b, CODE_FOR_atomic_orti },
  { 0x1020007, CODE_FOR_atomic_storeqi },
  { 0x1020008, CODE_FOR_atomic_storehi },
  { 0x1020009, CODE_FOR_atomic_storesi },
  { 0x102000a, CODE_FOR_atomic_storedi },
  { 0x102000b, CODE_FOR_atomic_storeti },
  { 0x1030007, CODE_FOR_atomic_sub_fetchqi },
  { 0x1030008, CODE_FOR_atomic_sub_fetchhi },
  { 0x1030009, CODE_FOR_atomic_sub_fetchsi },
  { 0x103000a, CODE_FOR_atomic_sub_fetchdi },
  { 0x103000b, CODE_FOR_atomic_sub_fetchti },
  { 0x1040007, CODE_FOR_atomic_subqi },
  { 0x1040008, CODE_FOR_atomic_subhi },
  { 0x1040009, CODE_FOR_atomic_subsi },
  { 0x104000a, CODE_FOR_atomic_subdi },
  { 0x104000b, CODE_FOR_atomic_subti },
  { 0x1050007, CODE_FOR_atomic_xor_fetchqi },
  { 0x1050008, CODE_FOR_atomic_xor_fetchhi },
  { 0x1050009, CODE_FOR_atomic_xor_fetchsi },
  { 0x105000a, CODE_FOR_atomic_xor_fetchdi },
  { 0x105000b, CODE_FOR_atomic_xor_fetchti },
  { 0x1060007, CODE_FOR_atomic_xorqi },
  { 0x1060008, CODE_FOR_atomic_xorhi },
  { 0x1060009, CODE_FOR_atomic_xorsi },
  { 0x106000a, CODE_FOR_atomic_xordi },
  { 0x106000b, CODE_FOR_atomic_xorti },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqihi2;
  ena[1] = HAVE_extendqisi2;
  ena[2] = HAVE_extendqidi2;
  ena[3] = HAVE_extendhisi2;
  ena[4] = HAVE_extendhidi2;
  ena[5] = HAVE_extendsidi2;
  ena[6] = HAVE_extendsfdf2;
  ena[7] = HAVE_extendsftf2;
  ena[8] = HAVE_extenddftf2;
  ena[9] = HAVE_extendsddd2;
  ena[10] = HAVE_extendsdtd2;
  ena[11] = HAVE_extendddtd2;
  ena[12] = HAVE_truncdfsf2;
  ena[13] = HAVE_trunctfsf2;
  ena[14] = HAVE_trunctfdf2;
  ena[15] = HAVE_truncddsd2;
  ena[16] = HAVE_trunctddd2;
  ena[17] = HAVE_zero_extendqihi2;
  ena[18] = HAVE_zero_extendqisi2;
  ena[19] = HAVE_zero_extendqidi2;
  ena[20] = HAVE_zero_extendhisi2;
  ena[21] = HAVE_zero_extendhidi2;
  ena[22] = HAVE_zero_extendsidi2;
  ena[23] = HAVE_fixdddi2;
  ena[24] = HAVE_fixtddi2;
  ena[25] = HAVE_floatsisf2;
  ena[26] = HAVE_floatsidf2;
  ena[27] = HAVE_floatsitf2;
  ena[28] = HAVE_floatdisf2;
  ena[29] = HAVE_floatdidf2;
  ena[30] = HAVE_floatdidd2;
  ena[31] = HAVE_floatditd2;
  ena[32] = HAVE_floatv4siv4sf2;
  ena[33] = HAVE_floatv2div2df2;
  ena[34] = HAVE_floatunssisf2;
  ena[35] = HAVE_floatunssidf2;
  ena[36] = HAVE_floatunsdisf2;
  ena[37] = HAVE_floatunsdidf2;
  ena[38] = HAVE_floatunsv4siv4sf2;
  ena[39] = HAVE_floatunsv2div2df2;
  ena[40] = HAVE_lrintsfdi2;
  ena[41] = HAVE_lrintdfdi2;
  ena[42] = HAVE_lroundsfdi2;
  ena[43] = HAVE_lrounddfdi2;
  ena[44] = HAVE_fix_truncsfsi2;
  ena[45] = HAVE_fix_truncsfdi2;
  ena[46] = HAVE_fix_truncdfsi2;
  ena[47] = HAVE_fix_truncdfdi2;
  ena[48] = HAVE_fix_trunctfsi2;
  ena[49] = HAVE_fix_truncv4sfv4si2;
  ena[50] = HAVE_fix_truncv2dfv2di2;
  ena[51] = HAVE_fixuns_truncsfsi2;
  ena[52] = HAVE_fixuns_truncsfdi2;
  ena[53] = HAVE_fixuns_truncdfsi2;
  ena[54] = HAVE_fixuns_truncdfdi2;
  ena[55] = HAVE_fixuns_truncv4sfv4si2;
  ena[56] = HAVE_fixuns_truncv2dfv2di2;
  ena[57] = HAVE_mulsidi3;
  ena[58] = HAVE_mulditi3;
  ena[59] = HAVE_umulsidi3;
  ena[60] = HAVE_umulditi3;
  ena[61] = HAVE_vcondv16qiv16qi;
  ena[62] = HAVE_vcondv8hiv8hi;
  ena[63] = HAVE_vcondv4siv4si;
  ena[64] = HAVE_vcondv4sfv4si;
  ena[65] = HAVE_vcondv2div2di;
  ena[66] = HAVE_vcondv4siv4sf;
  ena[67] = HAVE_vcondv4sfv4sf;
  ena[68] = HAVE_vcondv2dfv2df;
  ena[69] = HAVE_vconduv16qiv16qi;
  ena[70] = HAVE_vconduv8hiv8hi;
  ena[71] = HAVE_vconduv4siv4si;
  ena[72] = HAVE_vconduv4sfv4si;
  ena[73] = HAVE_vconduv2div2di;
  ena[74] = HAVE_addsi3;
  ena[75] = HAVE_adddi3;
  ena[76] = HAVE_addti3;
  ena[77] = HAVE_addsf3;
  ena[78] = HAVE_adddf3;
  ena[79] = HAVE_adddd3;
  ena[80] = HAVE_addtd3;
  ena[81] = HAVE_addv16qi3;
  ena[82] = HAVE_addv8hi3;
  ena[83] = HAVE_addv4si3;
  ena[84] = HAVE_addv2di3;
  ena[85] = HAVE_addv4sf3;
  ena[86] = HAVE_addv2df3;
  ena[87] = HAVE_subsi3;
  ena[88] = HAVE_subdi3;
  ena[89] = HAVE_subti3;
  ena[90] = HAVE_subsf3;
  ena[91] = HAVE_subdf3;
  ena[92] = HAVE_subdd3;
  ena[93] = HAVE_subtd3;
  ena[94] = HAVE_subv16qi3;
  ena[95] = HAVE_subv8hi3;
  ena[96] = HAVE_subv4si3;
  ena[97] = HAVE_subv2di3;
  ena[98] = HAVE_subv4sf3;
  ena[99] = HAVE_subv2df3;
  ena[100] = HAVE_mulsi3;
  ena[101] = HAVE_muldi3;
  ena[102] = HAVE_mulsf3;
  ena[103] = HAVE_muldf3;
  ena[104] = HAVE_muldd3;
  ena[105] = HAVE_multd3;
  ena[106] = HAVE_mulv8hi3;
  ena[107] = HAVE_mulv4si3;
  ena[108] = HAVE_mulv4sf3;
  ena[109] = HAVE_mulv2df3;
  ena[110] = HAVE_divsi3;
  ena[111] = HAVE_divdi3;
  ena[112] = HAVE_divsf3;
  ena[113] = HAVE_divdf3;
  ena[114] = HAVE_divdd3;
  ena[115] = HAVE_divtd3;
  ena[116] = HAVE_divv4sf3;
  ena[117] = HAVE_divv2df3;
  ena[118] = HAVE_udivsi3;
  ena[119] = HAVE_udivdi3;
  ena[120] = HAVE_modsi3;
  ena[121] = HAVE_moddi3;
  ena[122] = HAVE_ftruncdd2;
  ena[123] = HAVE_ftrunctd2;
  ena[124] = HAVE_ftruncv4sf2;
  ena[125] = HAVE_ftruncv2df2;
  ena[126] = HAVE_andsi3;
  ena[127] = HAVE_anddi3;
  ena[128] = HAVE_andti3;
  ena[129] = HAVE_andpti3;
  ena[130] = HAVE_andcti3;
  ena[131] = HAVE_andv16qi3;
  ena[132] = HAVE_andv8hi3;
  ena[133] = HAVE_andv4si3;
  ena[134] = HAVE_andv2di3;
  ena[135] = HAVE_andv1ti3;
  ena[136] = HAVE_andv4sf3;
  ena[137] = HAVE_andv2df3;
  ena[138] = HAVE_iorsi3;
  ena[139] = HAVE_iordi3;
  ena[140] = HAVE_iorti3;
  ena[141] = HAVE_iorpti3;
  ena[142] = HAVE_iorv16qi3;
  ena[143] = HAVE_iorv8hi3;
  ena[144] = HAVE_iorv4si3;
  ena[145] = HAVE_iorv2di3;
  ena[146] = HAVE_iorv1ti3;
  ena[147] = HAVE_iorv4sf3;
  ena[148] = HAVE_iorv2df3;
  ena[149] = HAVE_xorsi3;
  ena[150] = HAVE_xordi3;
  ena[151] = HAVE_xorti3;
  ena[152] = HAVE_xorpti3;
  ena[153] = HAVE_xorv16qi3;
  ena[154] = HAVE_xorv8hi3;
  ena[155] = HAVE_xorv4si3;
  ena[156] = HAVE_xorv2di3;
  ena[157] = HAVE_xorv1ti3;
  ena[158] = HAVE_xorv4sf3;
  ena[159] = HAVE_xorv2df3;
  ena[160] = HAVE_ashlsi3;
  ena[161] = HAVE_ashldi3;
  ena[162] = HAVE_ashrsi3;
  ena[163] = HAVE_ashrdi3;
  ena[164] = HAVE_lshrsi3;
  ena[165] = HAVE_lshrdi3;
  ena[166] = HAVE_rotlsi3;
  ena[167] = HAVE_rotldi3;
  ena[168] = HAVE_vashlv16qi3;
  ena[169] = HAVE_vashlv8hi3;
  ena[170] = HAVE_vashlv4si3;
  ena[171] = HAVE_vashlv2di3;
  ena[172] = HAVE_vashrv16qi3;
  ena[173] = HAVE_vashrv8hi3;
  ena[174] = HAVE_vashrv4si3;
  ena[175] = HAVE_vashrv2di3;
  ena[176] = HAVE_vlshrv16qi3;
  ena[177] = HAVE_vlshrv8hi3;
  ena[178] = HAVE_vlshrv4si3;
  ena[179] = HAVE_vlshrv2di3;
  ena[180] = HAVE_vrotlv16qi3;
  ena[181] = HAVE_vrotlv8hi3;
  ena[182] = HAVE_vrotlv4si3;
  ena[183] = HAVE_vrotlv2di3;
  ena[184] = HAVE_sminsf3;
  ena[185] = HAVE_smindf3;
  ena[186] = HAVE_sminv16qi3;
  ena[187] = HAVE_sminv8hi3;
  ena[188] = HAVE_sminv4si3;
  ena[189] = HAVE_sminv2di3;
  ena[190] = HAVE_sminv4sf3;
  ena[191] = HAVE_sminv2df3;
  ena[192] = HAVE_smaxsf3;
  ena[193] = HAVE_smaxdf3;
  ena[194] = HAVE_smaxv16qi3;
  ena[195] = HAVE_smaxv8hi3;
  ena[196] = HAVE_smaxv4si3;
  ena[197] = HAVE_smaxv2di3;
  ena[198] = HAVE_smaxv4sf3;
  ena[199] = HAVE_smaxv2df3;
  ena[200] = HAVE_uminv16qi3;
  ena[201] = HAVE_uminv8hi3;
  ena[202] = HAVE_uminv4si3;
  ena[203] = HAVE_uminv2di3;
  ena[204] = HAVE_umaxv16qi3;
  ena[205] = HAVE_umaxv8hi3;
  ena[206] = HAVE_umaxv4si3;
  ena[207] = HAVE_umaxv2di3;
  ena[208] = HAVE_negsi2;
  ena[209] = HAVE_negdi2;
  ena[210] = HAVE_negsf2;
  ena[211] = HAVE_negdf2;
  ena[212] = HAVE_negtf2;
  ena[213] = HAVE_negdd2;
  ena[214] = HAVE_negtd2;
  ena[215] = HAVE_negv16qi2;
  ena[216] = HAVE_negv8hi2;
  ena[217] = HAVE_negv4si2;
  ena[218] = HAVE_negv4sf2;
  ena[219] = HAVE_negv2df2;
  ena[220] = HAVE_abssf2;
  ena[221] = HAVE_absdf2;
  ena[222] = HAVE_abstf2;
  ena[223] = HAVE_absdd2;
  ena[224] = HAVE_abstd2;
  ena[225] = HAVE_absv16qi2;
  ena[226] = HAVE_absv8hi2;
  ena[227] = HAVE_absv4si2;
  ena[228] = HAVE_absv2di2;
  ena[229] = HAVE_absv4sf2;
  ena[230] = HAVE_absv2df2;
  ena[231] = HAVE_one_cmplsi2;
  ena[232] = HAVE_one_cmpldi2;
  ena[233] = HAVE_one_cmplti2;
  ena[234] = HAVE_one_cmplpti2;
  ena[235] = HAVE_one_cmplv16qi2;
  ena[236] = HAVE_one_cmplv8hi2;
  ena[237] = HAVE_one_cmplv4si2;
  ena[238] = HAVE_one_cmplv2di2;
  ena[239] = HAVE_one_cmplv1ti2;
  ena[240] = HAVE_one_cmplv4sf2;
  ena[241] = HAVE_one_cmplv2df2;
  ena[242] = HAVE_bswaphi2;
  ena[243] = HAVE_bswapsi2;
  ena[244] = HAVE_bswapdi2;
  ena[245] = HAVE_ffssi2;
  ena[246] = HAVE_ffsdi2;
  ena[247] = HAVE_clzsi2;
  ena[248] = HAVE_clzdi2;
  ena[249] = HAVE_clzv16qi2;
  ena[250] = HAVE_clzv8hi2;
  ena[251] = HAVE_clzv4si2;
  ena[252] = HAVE_clzv2di2;
  ena[253] = HAVE_ctzsi2;
  ena[254] = HAVE_ctzdi2;
  ena[255] = HAVE_popcountsi2;
  ena[256] = HAVE_popcountdi2;
  ena[257] = HAVE_popcountv16qi2;
  ena[258] = HAVE_popcountv8hi2;
  ena[259] = HAVE_popcountv4si2;
  ena[260] = HAVE_popcountv2di2;
  ena[261] = HAVE_paritysi2;
  ena[262] = HAVE_paritydi2;
  ena[263] = HAVE_sqrtsf2;
  ena[264] = HAVE_sqrtdf2;
  ena[265] = HAVE_sqrtv4sf2;
  ena[266] = HAVE_sqrtv2df2;
  ena[267] = HAVE_movcc;
  ena[268] = HAVE_movqi;
  ena[269] = HAVE_movhi;
  ena[270] = HAVE_movsi;
  ena[271] = HAVE_movdi;
  ena[272] = HAVE_movti;
  ena[273] = HAVE_movpti;
  ena[274] = HAVE_movsf;
  ena[275] = HAVE_movdf;
  ena[276] = HAVE_movtf;
  ena[277] = HAVE_movsd;
  ena[278] = HAVE_movdd;
  ena[279] = HAVE_movtd;
  ena[280] = HAVE_movv16qi;
  ena[281] = HAVE_movv8hi;
  ena[282] = HAVE_movv4si;
  ena[283] = HAVE_movv2di;
  ena[284] = HAVE_movv1ti;
  ena[285] = HAVE_movv4sf;
  ena[286] = HAVE_movv2df;
  ena[287] = HAVE_movmisalignv4si;
  ena[288] = HAVE_movmisalignv2di;
  ena[289] = HAVE_movmisalignv1ti;
  ena[290] = HAVE_movmisalignv4sf;
  ena[291] = HAVE_movmisalignv2df;
  ena[292] = HAVE_cbranchsi4;
  ena[293] = HAVE_cbranchdi4;
  ena[294] = HAVE_cbranchsf4;
  ena[295] = HAVE_cbranchdf4;
  ena[296] = HAVE_cbranchtf4;
  ena[297] = HAVE_cbranchdd4;
  ena[298] = HAVE_cbranchtd4;
  ena[299] = HAVE_movsicc;
  ena[300] = HAVE_movdicc;
  ena[301] = HAVE_movsfcc;
  ena[302] = HAVE_movdfcc;
  ena[303] = HAVE_cstoresi4;
  ena[304] = HAVE_cstoredi4;
  ena[305] = HAVE_cstoresf4;
  ena[306] = HAVE_cstoredf4;
  ena[307] = HAVE_cstoretf4;
  ena[308] = HAVE_cstoredd4;
  ena[309] = HAVE_cstoretd4;
  ena[310] = HAVE_ctrapsi4;
  ena[311] = HAVE_ctrapdi4;
  ena[312] = HAVE_smulsi3_highpart;
  ena[313] = HAVE_smuldi3_highpart;
  ena[314] = HAVE_umulsi3_highpart;
  ena[315] = HAVE_umuldi3_highpart;
  ena[316] = HAVE_movmemsi;
  ena[317] = HAVE_setmemsi;
  ena[318] = HAVE_strlensi;
  ena[319] = HAVE_fmasf4;
  ena[320] = HAVE_fmadf4;
  ena[321] = HAVE_fmav4sf4;
  ena[322] = HAVE_fmav2df4;
  ena[323] = HAVE_fmssf4;
  ena[324] = HAVE_fmsdf4;
  ena[325] = HAVE_fmsv4sf4;
  ena[326] = HAVE_fmsv2df4;
  ena[327] = HAVE_fnmasf4;
  ena[328] = HAVE_fnmadf4;
  ena[329] = HAVE_fnmav2sf4;
  ena[330] = HAVE_fnmav4sf4;
  ena[331] = HAVE_fnmav2df4;
  ena[332] = HAVE_fnmssf4;
  ena[333] = HAVE_fnmsdf4;
  ena[334] = HAVE_fnmsv2sf4;
  ena[335] = HAVE_fnmsv4sf4;
  ena[336] = HAVE_fnmsv2df4;
  ena[337] = HAVE_roundsf2;
  ena[338] = HAVE_rounddf2;
  ena[339] = HAVE_floorsf2;
  ena[340] = HAVE_floordf2;
  ena[341] = HAVE_ceilsf2;
  ena[342] = HAVE_ceildf2;
  ena[343] = HAVE_btruncsf2;
  ena[344] = HAVE_btruncdf2;
  ena[345] = HAVE_copysignsf3;
  ena[346] = HAVE_copysigndf3;
  ena[347] = HAVE_signbittf2;
  ena[348] = HAVE_reduc_smax_v4sf;
  ena[349] = HAVE_reduc_smax_v2df;
  ena[350] = HAVE_reduc_smin_v4sf;
  ena[351] = HAVE_reduc_smin_v2df;
  ena[352] = HAVE_reduc_splus_v16qi;
  ena[353] = HAVE_reduc_splus_v8hi;
  ena[354] = HAVE_reduc_splus_v4sf;
  ena[355] = HAVE_reduc_splus_v2df;
  ena[356] = HAVE_reduc_uplus_v16qi;
  ena[357] = HAVE_sdot_prodv8hi;
  ena[358] = HAVE_widen_ssumv16qi3;
  ena[359] = HAVE_widen_ssumv8hi3;
  ena[360] = HAVE_udot_prodv16qi;
  ena[361] = HAVE_udot_prodv8hi;
  ena[362] = HAVE_widen_usumv16qi3;
  ena[363] = HAVE_widen_usumv8hi3;
  ena[364] = HAVE_vec_extractv16qi;
  ena[365] = HAVE_vec_extractv8hi;
  ena[366] = HAVE_vec_extractv4si;
  ena[367] = HAVE_vec_extractv2di;
  ena[368] = HAVE_vec_extractv4sf;
  ena[369] = HAVE_vec_extractv2df;
  ena[370] = HAVE_vec_initv16qi;
  ena[371] = HAVE_vec_initv8hi;
  ena[372] = HAVE_vec_initv4si;
  ena[373] = HAVE_vec_initv2di;
  ena[374] = HAVE_vec_initv4sf;
  ena[375] = HAVE_vec_initv2df;
  ena[376] = HAVE_vec_pack_sfix_trunc_v2df;
  ena[377] = HAVE_vec_pack_trunc_v8hi;
  ena[378] = HAVE_vec_pack_trunc_v4si;
  ena[379] = HAVE_vec_pack_trunc_v2di;
  ena[380] = HAVE_vec_pack_trunc_v2df;
  ena[381] = HAVE_vec_pack_ufix_trunc_v2df;
  ena[382] = HAVE_vec_perm_constv16qi;
  ena[383] = HAVE_vec_perm_constv2di;
  ena[384] = HAVE_vec_perm_constv2df;
  ena[385] = HAVE_vec_permv16qi;
  ena[386] = HAVE_vec_realign_load_v16qi;
  ena[387] = HAVE_vec_realign_load_v8hi;
  ena[388] = HAVE_vec_realign_load_v4si;
  ena[389] = HAVE_vec_realign_load_v4sf;
  ena[390] = HAVE_vec_setv16qi;
  ena[391] = HAVE_vec_setv8hi;
  ena[392] = HAVE_vec_setv4si;
  ena[393] = HAVE_vec_setv2di;
  ena[394] = HAVE_vec_setv4sf;
  ena[395] = HAVE_vec_setv2df;
  ena[396] = HAVE_vec_shr_ti;
  ena[397] = HAVE_vec_shr_v16qi;
  ena[398] = HAVE_vec_shr_v8hi;
  ena[399] = HAVE_vec_shr_v4si;
  ena[400] = HAVE_vec_shr_v2di;
  ena[401] = HAVE_vec_shr_v1ti;
  ena[402] = HAVE_vec_shr_v4sf;
  ena[403] = HAVE_vec_shr_v2df;
  ena[404] = HAVE_vec_unpacks_float_hi_v8hi;
  ena[405] = HAVE_vec_unpacks_float_hi_v4si;
  ena[406] = HAVE_vec_unpacks_float_lo_v8hi;
  ena[407] = HAVE_vec_unpacks_float_lo_v4si;
  ena[408] = HAVE_vec_unpacks_hi_v16qi;
  ena[409] = HAVE_vec_unpacks_hi_v8hi;
  ena[410] = HAVE_vec_unpacks_hi_v4si;
  ena[411] = HAVE_vec_unpacks_hi_v4sf;
  ena[412] = HAVE_vec_unpacks_lo_v16qi;
  ena[413] = HAVE_vec_unpacks_lo_v8hi;
  ena[414] = HAVE_vec_unpacks_lo_v4si;
  ena[415] = HAVE_vec_unpacks_lo_v4sf;
  ena[416] = HAVE_vec_unpacku_float_hi_v8hi;
  ena[417] = HAVE_vec_unpacku_float_hi_v4si;
  ena[418] = HAVE_vec_unpacku_float_lo_v8hi;
  ena[419] = HAVE_vec_unpacku_float_lo_v4si;
  ena[420] = HAVE_vec_unpacku_hi_v16qi;
  ena[421] = HAVE_vec_unpacku_hi_v8hi;
  ena[422] = HAVE_vec_unpacku_lo_v16qi;
  ena[423] = HAVE_vec_unpacku_lo_v8hi;
  ena[424] = HAVE_vec_widen_smult_even_v16qi;
  ena[425] = HAVE_vec_widen_smult_even_v8hi;
  ena[426] = HAVE_vec_widen_smult_hi_v16qi;
  ena[427] = HAVE_vec_widen_smult_hi_v8hi;
  ena[428] = HAVE_vec_widen_smult_lo_v16qi;
  ena[429] = HAVE_vec_widen_smult_lo_v8hi;
  ena[430] = HAVE_vec_widen_smult_odd_v16qi;
  ena[431] = HAVE_vec_widen_smult_odd_v8hi;
  ena[432] = HAVE_vec_widen_umult_even_v16qi;
  ena[433] = HAVE_vec_widen_umult_even_v8hi;
  ena[434] = HAVE_vec_widen_umult_hi_v16qi;
  ena[435] = HAVE_vec_widen_umult_hi_v8hi;
  ena[436] = HAVE_vec_widen_umult_lo_v16qi;
  ena[437] = HAVE_vec_widen_umult_lo_v8hi;
  ena[438] = HAVE_vec_widen_umult_odd_v16qi;
  ena[439] = HAVE_vec_widen_umult_odd_v8hi;
  ena[440] = HAVE_atomic_add_fetchqi;
  ena[441] = HAVE_atomic_add_fetchhi;
  ena[442] = HAVE_atomic_add_fetchsi;
  ena[443] = HAVE_atomic_add_fetchdi;
  ena[444] = HAVE_atomic_add_fetchti;
  ena[445] = HAVE_atomic_addqi;
  ena[446] = HAVE_atomic_addhi;
  ena[447] = HAVE_atomic_addsi;
  ena[448] = HAVE_atomic_adddi;
  ena[449] = HAVE_atomic_addti;
  ena[450] = HAVE_atomic_and_fetchqi;
  ena[451] = HAVE_atomic_and_fetchhi;
  ena[452] = HAVE_atomic_and_fetchsi;
  ena[453] = HAVE_atomic_and_fetchdi;
  ena[454] = HAVE_atomic_and_fetchti;
  ena[455] = HAVE_atomic_andqi;
  ena[456] = HAVE_atomic_andhi;
  ena[457] = HAVE_atomic_andsi;
  ena[458] = HAVE_atomic_anddi;
  ena[459] = HAVE_atomic_andti;
  ena[460] = HAVE_atomic_compare_and_swapqi;
  ena[461] = HAVE_atomic_compare_and_swaphi;
  ena[462] = HAVE_atomic_compare_and_swapsi;
  ena[463] = HAVE_atomic_compare_and_swapdi;
  ena[464] = HAVE_atomic_compare_and_swapti;
  ena[465] = HAVE_atomic_exchangeqi;
  ena[466] = HAVE_atomic_exchangehi;
  ena[467] = HAVE_atomic_exchangesi;
  ena[468] = HAVE_atomic_exchangedi;
  ena[469] = HAVE_atomic_exchangeti;
  ena[470] = HAVE_atomic_fetch_addqi;
  ena[471] = HAVE_atomic_fetch_addhi;
  ena[472] = HAVE_atomic_fetch_addsi;
  ena[473] = HAVE_atomic_fetch_adddi;
  ena[474] = HAVE_atomic_fetch_addti;
  ena[475] = HAVE_atomic_fetch_andqi;
  ena[476] = HAVE_atomic_fetch_andhi;
  ena[477] = HAVE_atomic_fetch_andsi;
  ena[478] = HAVE_atomic_fetch_anddi;
  ena[479] = HAVE_atomic_fetch_andti;
  ena[480] = HAVE_atomic_fetch_nandqi;
  ena[481] = HAVE_atomic_fetch_nandhi;
  ena[482] = HAVE_atomic_fetch_nandsi;
  ena[483] = HAVE_atomic_fetch_nanddi;
  ena[484] = HAVE_atomic_fetch_nandti;
  ena[485] = HAVE_atomic_fetch_orqi;
  ena[486] = HAVE_atomic_fetch_orhi;
  ena[487] = HAVE_atomic_fetch_orsi;
  ena[488] = HAVE_atomic_fetch_ordi;
  ena[489] = HAVE_atomic_fetch_orti;
  ena[490] = HAVE_atomic_fetch_subqi;
  ena[491] = HAVE_atomic_fetch_subhi;
  ena[492] = HAVE_atomic_fetch_subsi;
  ena[493] = HAVE_atomic_fetch_subdi;
  ena[494] = HAVE_atomic_fetch_subti;
  ena[495] = HAVE_atomic_fetch_xorqi;
  ena[496] = HAVE_atomic_fetch_xorhi;
  ena[497] = HAVE_atomic_fetch_xorsi;
  ena[498] = HAVE_atomic_fetch_xordi;
  ena[499] = HAVE_atomic_fetch_xorti;
  ena[500] = HAVE_atomic_loadqi;
  ena[501] = HAVE_atomic_loadhi;
  ena[502] = HAVE_atomic_loadsi;
  ena[503] = HAVE_atomic_loaddi;
  ena[504] = HAVE_atomic_loadti;
  ena[505] = HAVE_atomic_nand_fetchqi;
  ena[506] = HAVE_atomic_nand_fetchhi;
  ena[507] = HAVE_atomic_nand_fetchsi;
  ena[508] = HAVE_atomic_nand_fetchdi;
  ena[509] = HAVE_atomic_nand_fetchti;
  ena[510] = HAVE_atomic_nandqi;
  ena[511] = HAVE_atomic_nandhi;
  ena[512] = HAVE_atomic_nandsi;
  ena[513] = HAVE_atomic_nanddi;
  ena[514] = HAVE_atomic_nandti;
  ena[515] = HAVE_atomic_or_fetchqi;
  ena[516] = HAVE_atomic_or_fetchhi;
  ena[517] = HAVE_atomic_or_fetchsi;
  ena[518] = HAVE_atomic_or_fetchdi;
  ena[519] = HAVE_atomic_or_fetchti;
  ena[520] = HAVE_atomic_orqi;
  ena[521] = HAVE_atomic_orhi;
  ena[522] = HAVE_atomic_orsi;
  ena[523] = HAVE_atomic_ordi;
  ena[524] = HAVE_atomic_orti;
  ena[525] = HAVE_atomic_storeqi;
  ena[526] = HAVE_atomic_storehi;
  ena[527] = HAVE_atomic_storesi;
  ena[528] = HAVE_atomic_storedi;
  ena[529] = HAVE_atomic_storeti;
  ena[530] = HAVE_atomic_sub_fetchqi;
  ena[531] = HAVE_atomic_sub_fetchhi;
  ena[532] = HAVE_atomic_sub_fetchsi;
  ena[533] = HAVE_atomic_sub_fetchdi;
  ena[534] = HAVE_atomic_sub_fetchti;
  ena[535] = HAVE_atomic_subqi;
  ena[536] = HAVE_atomic_subhi;
  ena[537] = HAVE_atomic_subsi;
  ena[538] = HAVE_atomic_subdi;
  ena[539] = HAVE_atomic_subti;
  ena[540] = HAVE_atomic_xor_fetchqi;
  ena[541] = HAVE_atomic_xor_fetchhi;
  ena[542] = HAVE_atomic_xor_fetchsi;
  ena[543] = HAVE_atomic_xor_fetchdi;
  ena[544] = HAVE_atomic_xor_fetchti;
  ena[545] = HAVE_atomic_xorqi;
  ena[546] = HAVE_atomic_xorhi;
  ena[547] = HAVE_atomic_xorsi;
  ena[548] = HAVE_atomic_xordi;
  ena[549] = HAVE_atomic_xorti;
}

static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 16) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '4', "divmod", gen_int_libfunc },
  { '4', "udivmod", gen_int_libfunc },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

